Index: /trunk/expressoMail1_2/inc/class.phpmailer.php
===================================================================
--- /trunk/expressoMail1_2/inc/class.phpmailer.php	(revision 614)
+++ /trunk/expressoMail1_2/inc/class.phpmailer.php	(revision 1035)
@@ -101,4 +101,19 @@
 
     /**
+     * Sets the signed body of the message.  This automatically sets the
+     * email to multipart/signed.
+     * @var string
+     */
+    var $SignedBody           = false;
+    var $SMIME          	= false;
+    var $Certs_crypt		= array();
+    /**
+     * Sets the encrypted body of the message.  This automatically sets the
+     * email to multipart/encript.
+     * @var string
+     */
+    var $CryptedBody           = "";
+
+    /**
      * Sets word wrapping on the body of the message to a given number of 
      * characters.
@@ -148,4 +163,6 @@
 	var $SaveMessageInFolder = "";
 	var $SaveMessageAsDraft = "";
+
+    var $xMailer           = "";
 
     /////////////////////////////////////////////////
@@ -372,11 +389,22 @@
         $this->SetMessageType();
         $header .= $this->CreateHeader();
-        $body = $this->CreateBody();
-		
-        if($body == "") { return false; }
+
+        if ($this->SMIME == false)
+        {
+            $body = $this->CreateBody();
+            if($body == "")
+            {
+                return false;
+            }
+        }
 		
         // Choose the mailer
         switch($this->Mailer)
         {
+            // Usado para processar o email e retornar para a applet
+        	case "smime":
+                $retorno['body'] = $header.$this->LE.$body;
+                $retorno['type'] =  $this->write_message_type();
+        		return $retorno;
             case "sendmail":
                 $result = $this->SendmailSend($header, $body);
@@ -473,8 +501,15 @@
         include_once($this->PluginDir . "class.smtp.php");
         $error = "";
+
         $bad_rcpt = array();
-
+        $errorx = '';
         if(!$this->SmtpConnect())
             return false;
+
+        if($this->SMIME)
+        {
+            $header='';
+            $body = $this->Body;
+        }
 
         $smtp_from = ($this->Sender == "") ? $this->From : $this->Sender;
@@ -490,17 +525,43 @@
         for($i = 0; $i < count($this->to); $i++)
         {
-            if(!$this->smtp->Recipient($this->to[$i][0]))
-                $bad_rcpt[] = $this->to[$i][0];
+            if($this->valEm($this->to[$i][0]))
+            {
+                if(!$this->smtp->Recipient($this->to[$i][0]))  $bad_rcpt[] = $this->to[$i][0];
+            }
+            else
+            {
+                $errorx .= $this->to[$i][0] . ', ';
+            }
         }
         for($i = 0; $i < count($this->cc); $i++)
         {
-            if(!$this->smtp->Recipient($this->cc[$i][0]))
-                $bad_rcpt[] = $this->cc[$i][0];
+            if($this->valEm($this->cc[$i][0]))
+            {
+                if(!$this->smtp->Recipient($this->cc[$i][0])) $bad_rcpt[] = $this->cc[$i][0];
+            }
+			else
+            {
+                $errorx .= $this->cc[$i][0] . ', ';
+            }
         }
         for($i = 0; $i < count($this->bcc); $i++)
         {
-            if(!$this->smtp->Recipient($this->bcc[$i][0]))
-                $bad_rcpt[] = $this->bcc[$i][0];
-        }
+            if($this->valEm($this->bcc[$i][0]))
+            {
+                if(!$this->smtp->Recipient($this->bcc[$i][0])) $bad_rcpt[] = $this->bcc[$i][0];
+            }
+			else
+            {
+                $errorx .= $this->bcc[$i][0] . ', ';
+            }
+        }
+        if($errorx != '')
+		{
+			$error = $errorx;
+			$error = $this->Lang("recipients_failed")  . '  ' . $errorx;
+			$this->SetError($error);
+			$this->smtp->Reset();
+			return false;
+		}
 
         if(count($bad_rcpt) > 0) // Create error message
@@ -524,5 +585,93 @@
             return false;
         }
+
+        // Vai verificar se deve cifrar a msg ......
+        if(count($this->Certs_crypt) > 0)
+		{
+            // Vai cifrar a msg antes de enviar ......
+			include_once("../seguranca/classes/CertificadoB.php");
+
+            $teste1 = array();
+            $aux_cifra1 = $header . $body;
+
+            // Início relocação dos headers
+            // Esta relocação dos headers podem causar problemas.
+
+            $match = 0;
+            $pattern = '/^Disposition\-Notification\-To:.*\n/m';
+            $match = preg_match($pattern, $aux_cifra1, $teste1);
+
+            if (!empty($match)){
+                $aux_cifra1 = preg_replace($pattern, '', $aux_cifra1, 1); // retira o Disposition-Notification-To
+
+                $match = 0;
+                $teste2 = array();
+                $pattern = '/^MIME\-Version:.*\n/m';
+                $match = preg_match($pattern, $aux_cifra1, $teste2);
+                $aux_cifra1 = preg_replace($pattern, $teste1[0].$teste2[0], $aux_cifra1, 1); // Adiciona Disposition-Notification-To logo acima de MIME-Version
+
+            }
+            // Fim relocação dos headers
+
+           // Vai partir em duas partes a msg.  A primeira parte he a dos headers, e a segunda vai ser criptografada ...
+            $pos_content_type = strpos($aux_cifra1,'Content-Type:');
+            $pos_MIME_Version = strpos($aux_cifra1,'MIME-Version: 1.0' . chr(0x0D) . chr(0x0A));
+            $valx_len = 19;
+            if($pos_MIME_Version === False)
+		    {
+                $pos_MIME_Version = strpos($aux_cifra1,'MIME-Version: 1.0' . chr(0x0A));
+                $valx_len = 18;
+		    }
+
+            if($pos_MIME_Version >= $pos_content_type)
+            {
+                // nao deve enviar a msg..... O header MIME-Version com posicao invalida ......
+                $this->SetError('Formato dos headers da msg estao invalidos.(CD-17) - A');
+                $this->smtp->Reset();
+                return false;
+            }
+
+            $aux_cifra2 = array();
+            $aux_cifra2[] = substr($aux_cifra1,0,$pos_MIME_Version - 1);
+            $aux_cifra2[] = substr($aux_cifra1,$pos_MIME_Version + $valx_len);
+
+               /*
+			// este explode pode ser fonte de problemas .......
+			$aux_cifra2 = explode('MIME-Version: 1.0' . chr(0x0A), $aux_cifra1);
+			// Pode ocorrer um erro se nao tiver o header MIME-Version .....
+			if(count($aux_cifra2)  != 2 )
+				{
+					$aux_cifra2 = explode('MIME-Version: 1.0' . chr(0x0D) . chr(0x0A), $aux_cifra1);
+					if(count($aux_cifra2)  != 2 )
+						{
+							// nao deve enviar a msg..... nao tem o header MIME-Version ......
+							$this->SetError('Formato dos headers da msg estao invalidos.(CD-17) - ' . count($aux_cifra2));
+							$this->smtp->Reset();
+							return false;
+						}
+				}
+                */
+			$certificado = new certificadoB();
+			$h = array();
+			$aux_body = $certificado->encriptar($aux_cifra2[1], $this->Certs_crypt, $h);
+			if(!$aux_body)
+            {
+                $this->SetError('Ocorreu um erro. A msg nao foi enviada. (CD-18)');
+                $this->smtp->Reset();
+                return false;
+            }
+			// salvar sem cifra......
+			//$smtpSent = $this->smtp->Data($aux_cifra2[0] . $aux_body);
+
+			// salva a msg sifrada. neste caso deve ter sido adicionado o certificado do autor da msg......
+			$header = $aux_cifra2[0];
+			$body = $aux_body;
         $smtpSent = $this->smtp->Data($header . $body);
+        }
+        else
+		{
+			$smtpSent = $this->smtp->Data($header . $body);
+		}
+
         if(!$smtpSent)
         {
@@ -563,7 +712,8 @@
 				$header = substr($header, 0, $target) . $this->AddrAppend("Bcc", $this->bcc) . substr($header, $target);
 			}
-		
-			$new_header = str_replace("\n", "\r\n", $header);
-			$new_body = str_replace("\n", "\r\n", $body);
+            $new_headerx = str_replace(chr(0x0A),chr(0x0D).chr(0x0A), $header);
+			$new_bodyx = str_replace(chr(0x0A),chr(0x0D).chr(0x0A), $body);
+			$new_header = str_replace(chr(0x0D).chr(0x0D).chr(0x0A), chr(0x0D).chr(0x0A),$new_headerx);
+			$new_body = str_replace(chr(0x0D).chr(0x0D).chr(0x0A), chr(0x0D).chr(0x0A), $new_bodyx);
 			
 			if ($this->SaveMessageAsDraft){
@@ -576,4 +726,32 @@
         
         return $smtpSent;
+    }
+
+    function valEm($email)
+    {
+        $mail_retorno = FALSE;
+        if ((strlen($email) >= 6) && (substr_count($email,"@") == 1) && (substr($email,0,1) != "@") && (substr($email,strlen($email)-1,1) != "@"))
+        {
+            if ((!strstr($email,"'")) && (!strstr($email,"\"")) && (!strstr($email,"\\")) && (!strstr($email,"\$")) && (!strstr($email," ")))
+            {
+                //testa se tem caracter .
+                if (substr_count($email,".")>= 1)
+                {
+                    //obtem a terminação do dominio
+                    $term_dom = substr(strrchr ($email, '.'),1);
+                    //verifica se terminação do dominio esta correcta
+                    if (strlen($term_dom)>1 && strlen($term_dom)<5 && (!strstr($term_dom,"@")) )
+                    {
+                        $antes_dom = substr($email,0,strlen($email) - strlen($term_dom) - 1);
+                        $caracter_ult = substr($antes_dom,strlen($antes_dom)-1,1);
+                        if ($caracter_ult != "@" && $caracter_ult != ".")
+                        {
+                            $mail_retorno = TRUE;
+                        }
+                    }
+                }
+            }
+        }
+        return $mail_retorno;
     }
 
@@ -885,4 +1063,16 @@
         $result .= $this->HeaderLine("MIME-Version", "1.0");
 
+        $result .= $this->write_message_type();
+
+        if($this->Mailer != "mail")
+            $result .= $this->LE.$this->LE;
+
+        return $result;
+    }
+
+
+    function write_message_type()
+	{
+		$result = "";
         switch($this->message_type)
         {
@@ -891,5 +1081,5 @@
                 $result .= sprintf("Content-Type: %s; charset=\"%s\"",
                                     $this->ContentType, $this->CharSet);
-                break;
+                return $result;
             case "attachments":
                 // fall through
@@ -906,9 +1096,9 @@
                     $result .= $this->TextLine("\tboundary=\"" . $this->boundary[1] . '"');
                 }
-                break;
+                return $result;
             case "alt":
                 $result .= $this->HeaderLine("Content-Type", "multipart/alternative;");
                 $result .= $this->TextLine("\tboundary=\"" . $this->boundary[1] . '"');
-                break;
+                return $result;
         }
 
Index: /trunk/expressoMail1_2/inc/hook_settings.inc.php
===================================================================
--- /trunk/expressoMail1_2/inc/hook_settings.inc.php	(revision 1005)
+++ /trunk/expressoMail1_2/inc/hook_settings.inc.php	(revision 1035)
@@ -13,4 +13,47 @@
 $type = $_GET['type']; // FIX ME
 
+//if ($type == 'user' || $type == ''){
+create_html_code('<script language="JavaScript" type="text/javascript">
+function exibir_ocultar()
+{
+    var type = ("'.$type.'" == "") ? "user" : "'.$type.'";
+    var use_signature_digital_cripto = document.getElementsByName(type+"[use_signature_digital_cripto]")[0];
+    var default_signature_digital_cripto = "'.$GLOBALS['phpgw_info']['default']['preferences']['expressoMail']['use_signature_digital_cripto'].'";
+
+    if (use_signature_digital_cripto)
+    {
+        var element_signature_digital = document.getElementById(type+"[use_signature_digital]");
+        var element_signature_cripto = document.getElementById(type+"[use_signature_cripto]");
+
+        switch (use_signature_digital_cripto[use_signature_digital_cripto.selectedIndex].value){
+
+            case "1":
+                element_signature_digital.style.display="";
+                element_signature_cripto.style.display="";
+                break;
+            case "0":
+                element_signature_digital.style.display="none";
+                element_signature_cripto.style.display="none";
+                break;
+            case "":
+                if (default_signature_digital_cripto){
+                    element_signature_digital.style.display="";
+                    element_signature_cripto.style.display="";
+                 }
+                 else
+                 {
+                    element_signature_digital.style.display="none";
+                    element_signature_cripto.style.display="none";
+                 }
+
+        }
+
+    }
+
+}
+
+</script>');
+//}
+
 $default = array(
 	'25'	=> '25',
@@ -20,7 +63,7 @@
 );
 
-create_select_box(lang('What is the maximum number of messages per page?'),'max_email_per_page',$default,
+create_select_box('What is the maximum number of messages per page?','max_email_per_page',$default,
 	'What is the maximum number of messages per page?');
-create_check_box(lang('Save deleted messages in trash folder?'),'save_deleted_msg','Save deleted messages in trash folder?');
+create_check_box('Save deleted messages in trash folder?','save_deleted_msg','Save deleted messages in trash folder?');
 $default = array(
 	'1'    => lang('1 day'),
@@ -31,12 +74,12 @@
 );
 
-create_select_box(lang('Delete trash messages after how many days?'),'delete_trash_messages_after_n_days',$default,lang('Delete trash messages after how many days?'));
-create_check_box(lang('Would you like to use local messages?'),'use_local_messages','');
-create_check_box(lang('Would you like to keep archived messages?'),'keep_archived_messages','');
-create_check_box(lang('Show previous message, after delete actual message?'),'delete_and_show_previous_message','');
-create_check_box(lang('Do you wanna receive an alert for new messages?'),'alert_new_msg','');
-create_check_box(lang('Show default view on main screen?'),'mainscreen_showmail','');
-create_check_box(lang('Do you want to use remove attachments function?'),'remove_attachments_function','');
-create_check_box(lang('Do you want to use important flag in email editor?'),'enable_important_flag','');
+create_select_box('Delete trash messages after how many days?','delete_trash_messages_after_n_days',$default,lang('Delete trash messages after how many days?'));
+create_check_box('Would you like to use local messages?','use_local_messages','');
+create_check_box('Would you like to keep archived messages?','keep_archived_messages','');
+create_check_box('Show previous message, after delete actual message?','delete_and_show_previous_message','');
+create_check_box('Do you wanna receive an alert for new messages?','alert_new_msg','');
+create_check_box('Show default view on main screen?','mainscreen_showmail','');
+create_check_box('Do you want to use remove attachments function?','remove_attachments_function','');
+create_check_box('Do you want to use important flag in email editor?','enable_important_flag','');
 
 //TODO use default folders from email admin
@@ -47,6 +90,6 @@
 	'INBOX/'.lang('Trash')	=> lang('Trash')
 );
-create_select_box(lang('Save sent messages in folder'),'save_in_folder',$default,'');
-create_check_box(lang('Hide menu folders?'),'check_menu','');
+create_select_box('Save sent messages in folder','save_in_folder',$default,'');
+create_check_box('Hide menu folders?','check_menu','');
 
 $default = array(
@@ -56,5 +99,5 @@
 );
 
-create_select_box(lang('What is the height of the lines in the list of messages?'),'line_height',$default,'');
+create_select_box('What is the height of the lines in the list of messages?','line_height',$default,'');
 $default = array(
 	'10' => lang('small'),
@@ -63,8 +106,8 @@
 );
 
-create_select_box(lang('What the font size in the list of messages?'),'font_size',$default,'');
-create_check_box(lang('Use dynamic contacts?'),'use_dynamic_contacts','');
-create_check_box(lang('Use shortcuts?'),'use_shotcuts','');
-create_check_box(lang('Auto save draft'),'auto_save_draft','');
+create_select_box('What the font size in the list of messages?','font_size',$default,'');
+create_check_box('Use dynamic contacts?','use_dynamic_contacts','');
+create_check_box('Use shortcuts?','use_shotcuts','');
+create_check_box('Auto save draft','auto_save_draft','');
 $default = array(
 	'65536' => lang('unlimited'),
@@ -76,5 +119,20 @@
 );
 
-create_select_box(lang('What is the maximum size of embedded images')."?",'image_size',$default,'');
+create_select_box('What is the maximum size of embedded images'."?",'image_size',$default,'');
+
+if($GLOBALS['phpgw_info']['server']['use_assinar_criptografar'])
+{
+    create_check_box('Enable digitally sign/cipher the message?','use_signature_digital_cripto','','',True,'onchange="javascript:exibir_ocultar();"');
+    if ($GLOBALS['phpgw_info']['user']['preferences']['expressoMail']['use_signature_digital_cripto'])
+    {
+        create_check_box('Always sign message digitally?','use_signature_digital','');
+        create_check_box('Always cipher message digitally?','use_signature_cripto','');
+    }
+    else
+    {
+        create_check_box('Always sign message digitally?','use_signature_digital','','',True,'',False);
+        create_check_box('Always cipher message digitally?','use_signature_cripto','','',True,'',False);
+    }
+}
 
 $default = array(
@@ -83,5 +141,5 @@
 );
 
-create_select_box(lang('Signature Type'),'type_signature',$default,'','','','onchange="javascript:changeType(this.value);" onload="javascript:alert(this.value);"');
+create_select_box('Signature Type','type_signature',$default,'','','','onchange="javascript:changeType(this.value);" onload="javascript:alert(this.value);"');
 
 if ($type == 'user' || $type == ''){
Index: /trunk/expressoMail1_2/js/local_messages.js
===================================================================
--- /trunk/expressoMail1_2/js/local_messages.js	(revision 1000)
+++ /trunk/expressoMail1_2/js/local_messages.js	(revision 1035)
@@ -135,5 +135,5 @@
 	local_messages.prototype.get_local_mail = function(id_mail) {
 		this.init_local_messages();
-		var rs = this.dbGears.execute("select mail.rowid,mail.mail,mail.ffrom,mail.subject,mail.body,mail.fto,mail.cc,folder.folder from mail inner join folder on mail.id_folder=folder.rowid  where mail.rowid="+id_mail);
+		var rs = this.dbGears.execute("select mail.rowid,mail.mail,mail.ffrom,mail.subject,mail.body,mail.fto,mail.cc,folder.folder,mail.original_id from mail inner join folder on mail.id_folder=folder.rowid  where mail.rowid="+id_mail);
 		var retorno = null;
 		if(rs.isValidRow()) {
@@ -141,40 +141,57 @@
 		}
 		retorno = connector.unserialize(retorno);
-		
-		retorno['from'] = connector.unserialize(rs.field(2));
-		retorno['subject'] = rs.field(3);
-		retorno['body'] = rs.field(4);
-                //Codigo que as imagens embutidas em emails (com multipart/related ou multipart/mixed) sejam corretamente mostradas em emails arquivados. Os links do
-                //tipo "./inc/show_embedded_attach.php?msg_folder=[folder]&msg_num=[msg_num]&msg_part=[part]"
-                //são substituidos pelos links dos anexos capturados pelo gears.
-
-                var thumbs= retorno.thumbs;
-                var anexos= retorno.array_attach;
-                for (i in anexos)
-                {
-                    nomeArquivo = anexos[i]['name'].substring(0,anexos[i]['name'].length - 4);
-                    if(nomeArquivo.match('jpg')||anexos[i]['name'].match('gif')||anexos[i]['name'].match('png'))
-                        {
-                            var er_imagens = new RegExp("\\.\\/inc\\/show_embedded_attach.php\\?msg_folder=[\\w/]+\\&msg_num=[0-9]+\\&msg_part="+anexos[i]['pid']);
-                            var Result_imagens = er_imagens.exec(retorno['body']);
-                            retorno['body'] = retorno['body'].replace(Result_imagens,anexos[i]['url']);
-                            if(thumbs && thumbs[i]){
-                                er_imagens = new RegExp("\\.\\/inc\\/show_thumbs.php\\?file_type=image\\/[\\w]+\\&msg_num=[0-9]+\\&msg_folder=[\\w/%]+\\&msg_part="+anexos[i]['pid']);
-                                Result_imagens = er_imagens.exec(thumbs[i]);
-                                thumbs[i] = thumbs[i].replace(Result_imagens,"'"+anexos[i]['url']+"'");
-                                er_imagens = new RegExp("\\.\\/inc\\/show_img.php\\?msg_num=[0-9]+\\&msg_folder=[\\w/%]+\\&msg_part="+anexos[i]['pid']);
-                                Result_imagens = er_imagens.exec(thumbs[i]);
-                                thumbs[i] = thumbs[i].replace(Result_imagens,"'"+anexos[i]['url']+"'");
-                                thumbs[i] = thumbs[i].replace(/<IMG/i,'<img width="120"');
-                            }
+
+        //alert('tipo retorno.source: ' + typeof(retorno.source));
+
+        if (typeof(retorno.source) == 'string')
+        {
+            retorno.msg_number=rs.field(0);
+            retorno.original_ID=rs.field(8);
+            retorno.msg_folder=rs.field(7);
+
+            //alert('tipo retorno: '+typeof(retorno))
+            //show_msg(retorno);
+        }
+		else
+        {
+            retorno['from'] = connector.unserialize(rs.field(2));
+            retorno['subject'] = rs.field(3);
+            retorno['body'] = rs.field(4);
+            //Codigo que as imagens embutidas em emails (com multipart/related ou multipart/mixed) sejam corretamente mostradas em emails arquivados. Os links do
+            //tipo "./inc/show_embedded_attach.php?msg_folder=[folder]&msg_num=[msg_num]&msg_part=[part]"
+            //são substituidos pelos links dos anexos capturados pelo gears.
+
+            var thumbs= retorno.thumbs;
+            var anexos= retorno.array_attach;
+            for (i in anexos)
+            {
+                nomeArquivo = anexos[i]['name'].substring(0,anexos[i]['name'].length - 4);
+                if(nomeArquivo.match('jpg')||anexos[i]['name'].match('gif')||anexos[i]['name'].match('png'))
+                    {
+                        var er_imagens = new RegExp("\\.\\/inc\\/show_embedded_attach.php\\?msg_folder=[\\w/]+\\&msg_num=[0-9]+\\&msg_part="+anexos[i]['pid']);
+                        var Result_imagens = er_imagens.exec(retorno['body']);
+                        retorno['body'] = retorno['body'].replace(Result_imagens,anexos[i]['url']);
+                        if(thumbs && thumbs[i]){
+                            er_imagens = new RegExp("\\.\\/inc\\/show_thumbs.php\\?file_type=image\\/[\\w]+\\&msg_num=[0-9]+\\&msg_folder=[\\w/%]+\\&msg_part="+anexos[i]['pid']);
+                            Result_imagens = er_imagens.exec(thumbs[i]);
+                            thumbs[i] = thumbs[i].replace(Result_imagens,"'"+anexos[i]['url']+"'");
+                            er_imagens = new RegExp("\\.\\/inc\\/show_img.php\\?msg_num=[0-9]+\\&msg_folder=[\\w/%]+\\&msg_part="+anexos[i]['pid']);
+                            Result_imagens = er_imagens.exec(thumbs[i]);
+                            thumbs[i] = thumbs[i].replace(Result_imagens,"'"+anexos[i]['url']+"'");
+                            thumbs[i] = thumbs[i].replace(/<IMG/i,'<img width="120"');
                         }
-                }
-
-		retorno['to'] = connector.unserialize(rs.field(5));
-		retorno['cc'] = connector.unserialize(rs.field(6));
-		
-		retorno['local_message'] = true;
-		retorno['msg_folder'] = "local_"+rs.field(7); //Now it's a local folder 
-		retorno['msg_number'] = rs.field(0); //the message number is the rowid
+                    }
+            }
+
+            retorno['to'] = connector.unserialize(rs.field(5));
+            retorno['cc'] = connector.unserialize(rs.field(6));
+
+            retorno['local_message'] = true;
+            retorno['msg_folder'] = "local_"+rs.field(7); //Now it's a local folder
+            retorno['msg_number'] = rs.field(0); //the message number is the rowid
+
+        }
+
+        rs.close();
 		this.finalize();
 		return retorno;
@@ -671,4 +688,35 @@
     }
 
+    local_messages.prototype.get_msg_date = function (original_id, is_local){
+
+        this.init_local_messages();
+
+        if (typeof(is_local) == 'undefined')
+        {
+            is_local = false;
+        }
+
+        var rs;
+
+        if (is_local)
+        {
+            rs = this.dbGears.execute("select mail from mail where rowid="+original_id);
+        }
+        else
+        {
+            rs = this.dbGears.execute("select mail from mail where original_id="+original_id);
+        }
+        var tmp = connector.unserialize(rs.field(0));
+        var ret = new Array();
+        ret.fulldate = tmp.fulldate.substr(0,16);
+        ret.smalldate = tmp.msg_day;
+        ret.msg_day = tmp.msg_day;
+        ret.msg_hour = tmp.msg_day;
+
+        rs.close();
+        this.finalize();
+        return ret;
+    }
+
 
     local_messages.prototype.download_all_local_attachments = function(folder,id){
